## mupdf 1.27.0+ds1

=== Makefile ===
# GNU Makefile

-include user.make

ifndef build
  build := release
endif

default: apps libs

include Makerules

ifndef OUT
  OUT := build/$(build_prefix)$(build)$(build_suffix)
endif

include Makethird

# --- Configuration ---

# Do not specify CFLAGS, LDFLAGS, LIB_LDFLAGS, EXE_LDFLAGS or LIBS on the make
# invocation line - specify XCFLAGS, XLDFLAGS, XLIB_LDFLAGS, XEXE_LDFLAGS or
# XLIBS instead. Make ignores any lines in the makefile that set a variable
# that was set on the command line.
CFLAGS += $(XCFLAGS) -Iinclude
LIBS += $(XLIBS) -lm

LDFLAGS += $(XLDFLAGS)
LIB_LDFLAGS += $(XLIB_LDFLAGS)
EXE_LDFLAGS += $(XEXE_LDFLAGS)

ifneq ($(threading),no)
  ifeq ($(HAVE_PTHREAD),yes)
    THREADING_CFLAGS := $(PTHREAD_CFLAGS) -DHAVE_PTHREAD
    THREADING_LIBS := $(PTHREAD_LIBS)
  endif
endif

VERSION_MAJOR = $(shell grep "define FZ_VERSION_MAJOR" include/mupdf/fitz/version.h | cut -d ' ' -f 3)
VERSION_MINOR = $(shell grep "define FZ_VERSION_MINOR" include/mupdf/fitz/version.h | cut -d ' ' -f 3)
VERSION_PATCH = $(shell grep "define FZ_VERSION_PATCH" include/mupdf/fitz/version.h | cut -d ' ' -f 3)

ifneq ($(OS),Darwin)
  ifneq ($(USE_SONAME),no)
    SO_VERSION_MAJOR = .$(VERSION_MINOR)
    SO_VERSION = .$(VERSION_MINOR).$(VERSION_PATCH)
  endif
endif

# workaround argument list too long errors
ifeq (4.0,$(firstword $(sort $(MAKE_VERSION) 4.0)))
  USE_ARGUMENT_FILE=yes
else
  USE_ARGUMENT_FILE=no
endif

# --- Commands ---

ifneq ($(verbose),yes)
  QUIET_AR = @ echo "    AR $@" ;
  QUIET_RANLIB = @ echo "    RANLIB $@" ;
  QUIET_CC = @ echo "    CC $@" ;
  QUIET_CXX = @ echo "    CXX $@" ;
  QUIET_GEN = @ echo "    GEN $@" ;
  QUIET_LINK = @ echo "    LINK $@" ;
  QUIET_LINK_SO = @ echo "    LINK_SO $@" ;
  QUIET_RM = @ echo "    RM $@" ;
  QUIET_TAGS = @ echo "    TAGS $@" ;
  QUIET_OBJCOPY = @ echo "    OBJCOPY $@" ;
  QUIET_SYMLINK = @ echo "    SYMLINK $@" ;
endif

MKTGTDIR = mkdir -p $(dir $@)
CC_CMD = $(QUIET_CC) $(MKTGTDIR) ; $(CC) $(CFLAGS) -MMD -MP -o $@ -c $<
CXX_CMD = $(QUIET_CXX) $(MKTGTDIR) ; $(CXX) $(CFLAGS) $(XCXXFLAGS) -MMD -MP -o $@ -c $<
ifeq ($(USE_ARGUMENT_FILE),yes)
  AR_CMD = $(QUIET_AR) $(MKTGTDIR) ; $(AR) cr $@ $(file > $@.in,$^) @$@.in
else
  AR_CMD = $(QUIET_AR) $(MKTGTDIR) ; $(AR) cr $@ $^
endif
ifdef RANLIB
  RANLIB_CMD = $(QUIET_RANLIB) $(RANLIB) $@
endif
LINK_CMD = $(QUIET_LINK) $(MKTGTDIR) ; $(CC) $(EXE_LDFLAGS) $(LDFLAGS) -o $@ $^ $(LIBS)
TAGS_CMD = $(QUIET_TAGS) ctags
OBJCOPY_CMD = $(QUIET_OBJCOPY) $(MKTGTDIR) ; $(LD) -r -b binary -z noexecstack -o $@ $<
SYMLINK_CMD = $(QUIET_SYMLINK) $(MKTGTDIR) ; ln -sf

ifeq ($(shared),yes)
  ifeq ($(USE_ARGUMENT_FILE),yes)
    LINK_SO_CMD = $(QUIET_LINK_SO) $(MKTGTDIR) ; $(CC) $(LIB_LDFLAGS) $(LDFLAGS) -o $@ $(file > $@.in,$^) @$@.in
  else
    LINK_SO_CMD = $(QUIET_LINK_SO) $(MKTGTDIR) ; $(CC) $(LIB_LDFLAGS) $(LDFLAGS) -o $@ $^
  endif
  ifeq ($(OS),OpenBSD)
    # OpenBSD linker magic doesn't use soname; so fake it by using -L$(OUT) and -lmupdf.
    LINK_CMD = $(QUIET_LINK) $(MKTGTDIR) ; $(CC) $(EXE_LDFLAGS) $(LDFLAGS) -o $@ -L$(OUT) \
	$(subst $(OUT)/libmupdf.$(SO)$(SO_VERSION),-lmupdf,$^) \
	$(LIBS)
  endif
endif

# --- Rules ---

$(OUT)/%.a :
	$(AR_CMD)
	$(RANLIB_CMD)

$(OUT)/source/helpers/mu-threads/%.o : source/helpers/mu-threads/%.c
	$(CC_CMD) $(WARNING_CFLAGS) $(LIB_CFLAGS) $(THREADING_CFLAGS)

$(OUT)/source/helpers/pkcs7/%.o : source/helpers/pkcs7/%.c
	$(CC_CMD) $(WARNING_CFLAGS) $(LIB_CFLAGS) $(LIBCRYPTO_CFLAGS)

$(OUT)/source/tools/%.o : source/tools/%.c
	$(CC_CMD) $(LIB_CFLAGS) $(WARNING_CFLAGS) $(THIRD_CFLAGS) $(THREADING_CFLAGS)

$(OUT)/generated/%.o : generated/%.c
	$(CC_CMD) $(WARNING_CFLAGS) $(LIB_CFLAGS) -O0

$(OUT)/platform/x11/%.o : platform/x11/%.c
	$(CC_CMD) $(WARNING_CFLAGS) $(X11_CFLAGS)

$(OUT)/platform/x11/curl/%.o : platform/x11/%.c
	$(CC_CMD) $(WARNING_CFLAGS) $(X11_CFLAGS) $(CURL_CFLAGS)

$(OUT)/platform/gl/%.o : platform/gl/%.c
	$(CC_CMD) $(WARNING_CFLAGS) $(THIRD_CFLAGS) $(THIRD_GLUT_CFLAGS)

ifeq ($(HAVE_OBJCOPY),yes)
  $(OUT)/source/fitz/noto.o : source/fitz/noto.c
	$(CC_CMD) $(WARNING_CFLAGS) -Wdeclaration-after-statement -DHAVE_OBJCOPY $(LIB_CFLAGS) $(THIRD_CFLAGS)
  $(OUT)/source/fitz/hyphen.o : source/fitz/hyphen.c
	$(CC_CMD) $(WARNING_CFLAGS) -Wdeclaration-after-statement -DHAVE_OBJCOPY $(LIB_CFLAGS) $(THIRD_CFLAGS)
endif

$(OUT)/source/fitz/memento.o : source/fitz/memento.c
	$(CC_CMD) $(WARNING_CFLAGS) $(LIB_CFLAGS) $(THIRD_CFLAGS) -DMEMENTO_MUPDF_HACKS

$(OUT)/source/%.o : source/%.c
	$(CC_CMD) $(WARNING_CFLAGS) -Wdeclaration-after-statement $(LIB_CFLAGS) $(THIRD_CFLAGS)

$(OUT)/thirdparty/so/source/%.o : thirdparty/so/source/%.c
	$(CC_CMD) $(WARNING_CFLAGS) -Wdeclaration-after-statement $(LIB_CFLAGS) $(THIRD_CFLAGS)

$(OUT)/source/%.o : source/%.cpp
	$(CXX_CMD) $(WARNING_CFLAGS) $(LIB_CFLAGS) $(THIRD_CFLAGS)

ifeq ($(HAVE_TESSERACT),yes)
$(OUT)/source/fitz/tessocr.o : source/fitz/tessocr.cpp
	$(CXX_CMD) $(WARNING_CFLAGS) $(LIB_CFLAGS) $(THIRD_CFLAGS) $(TESSERACT_CFLAGS) $(TESSERACT_LANGFLAGS) $(LEPTONICA_CFLAGS)
endif

ifeq ($(HAVE_LEPTONICA),yes)
$(OUT)/source/fitz/leptonica-wrap.o : source/fitz/leptonica-wrap.c
	$(CC_CMD) $(WARNING_CFLAGS) $(LIB_CFLAGS) $(THIRD_CFLAGS) $(LEPTONICA_CFLAGS)
endif

ifeq ($(HAVE_ZXINGCPP),yes)
$(OUT)/source/fitz/zxingbarcode.o : source/fitz/zxingbarcode.cpp
	$(CXX_CMD) $(WARNING_CFLAGS) $(LIB_CFLAGS) $(THIRD_CFLAGS) $(ZXINGCPP_CFLAGS) $(ZXINGCPP_LANGFLAGS)
endif

$(OUT)/platform/%.o : platform/%.c
	$(CC_CMD) $(WARNING_CFLAGS)

.PRECIOUS : $(OUT)/%.o # Keep intermediates from chained rules

# --- File lists ---

THIRD_OBJ := $(THIRD_SRC:%.c=$(OUT)/%.o)
THIRD_OBJ := $(THIRD_OBJ:%.cc=$(OUT)/%.o)
THIRD_OBJ := $(THIRD_OBJ:%.cpp=$(OUT)/%.o)

THIRD_GLUT_OBJ := $(THIRD_GLUT_SRC:%.c=$(OUT)/%.o)

MUPDF_SRC := $(sort $(wildcard source/fitz/*.c))
MUPDF_SRC += $(sort $(wildcard source/fitz/*.cpp))
MUPDF_SRC += $(sort $(wildcard source/pdf/*.c))
ifneq ($(xps),no)
MUPDF_SRC += $(sort $(wildcard source/xps/*.c))
endif
ifneq ($(svg),no)
MUPDF_SRC += $(sort $(wildcard source/svg/*.c))
endif
ifneq ($(html),no)
MUPDF_SRC += $(sort $(wildcard source/html/*.c))
endif
MUPDF_SRC += $(sort $(wildcard source/reflow/*.c))
MUPDF_SRC += $(sort $(wildcard source/cbz/*.c))

MUPDF_OBJ := $(MUPDF_SRC:%.c=$(OUT)/%.o)
MUPDF_OBJ := $(MUPDF_OBJ:%.cpp=$(OUT)/%.o)

THREAD_SRC := source/helpers/mu-threads/mu-threads.c
THREAD_OBJ := $(THREAD_SRC:%.c=$(OUT)/%.o)

PKCS7_SRC += source/helpers/pkcs7/pkcs7-openssl.c
PKCS7_OBJ := $(PKCS7_SRC:%.c=$(OUT)/%.o)

# --- Generated embedded font files ---

HEXDUMP_SH := scripts/hexdump.sh

FONT_BIN := $(sort $(wildcard resources/fonts/urw/*.cff))
FONT_BIN += $(sort $(wildcard resources/fonts/han/*.ttc))
FONT_BIN += $(sort $(wildcard resources/fonts/droid/DroidSansFallbackFull.ttf))
FONT_BIN += $(sort $(wildcard resources/fonts/droid/DroidSansFallback.ttf))
FONT_BIN += $(sort $(wildcard resources/fonts/noto/*.otf))
FONT_BIN += $(sort $(wildcard resources/fonts/noto/*.ttf))
FONT_BIN += $(sort $(wildcard resources/fonts/sil/*.cff))

# Note: The tests here must match the equivalent tests in noto.c

ifneq ($(filter -DTOFU_CJK,$(CFLAGS)),)
  FONT_BIN := $(filter-out resources/fonts/han/%.ttc, $(FONT_BIN))
  FONT_BIN := $(filter-out resources/fonts/droid/DroidSansFallbackFull.ttf, $(FONT_BIN))
  FONT_BIN := $(filter-out resources/fonts/droid/DroidSansFallback.ttf, $(FONT_BIN))
endif

ifneq ($(filter -DTOFU_CJK_EXT,$(CFLAGS)),)
  FONT_BIN := $(filter-out resources/fonts/han/%.ttc, $(FONT_BIN))
  FONT_BIN := $(filter-out resources/fonts/droid/DroidSansFallbackFull.ttf, $(FONT_BIN))
endif

ifneq ($(filter -DTOFU_CJK_LANG,$(CFLAGS)),)
  FONT_BIN := $(filter-out resources/fonts/han/%.ttc, $(FONT_BIN))
endif

ifneq ($(filter -DTOFU,$(CFLAGS)),)
  FONT_BIN := $(filter-out resources/fonts/noto/%.otf,$(FONT_BIN))
  FONT_BIN := $(filter-out resources/fonts/noto/%.ttf,$(FONT_BIN))
  FONT_BIN := $(filter-out resources/fonts/sil/%.cff,$(FONT_BIN))
endif

ifneq ($(filter -DTOFU_NOTO,$(CFLAGS)),)
  FONT_BIN := $(filter-out resources/fonts/noto/%.otf,$(FONT_BIN))
  FONT_BIN := $(filter-out resources/fonts/noto/%.ttf,$(FONT_BIN))
endif

ifneq ($(filter -DTOFU_SIL,$(CFLAGS)),)
  FONT_BIN := $(filter-out resources/fonts/sil/%.cff,$(FONT_BIN))
endif

FONT_GEN := $(FONT_BIN:%=generated/%.c)

generated/%.cff.c : %.cff $(HEXDUMP_SH) ; $(QUIET_GEN) $(MKTGTDIR) ; bash $(HEXDUMP_SH) > $@ $<
generated/%.otf.c : %.otf $(HEXDUMP_SH) ; $(QUIET_GEN) $(MKTGTDIR) ; bash $(HEXDUMP_SH) > $@ $<
generated/%.ttf.c : %.ttf $(HEXDUMP_SH) ; $(QUIET_GEN) $(MKTGTDIR) ; bash $(HEXDUMP_SH) > $@ $<
generated/%.ttc.c : %.ttc $(HEXDUMP_SH) ; $(QUIET_GEN) $(MKTGTDIR) ; bash $(HEXDUMP_SH) > $@ $<

ifeq ($(HAVE_OBJCOPY),yes)
  MUPDF_OBJ += $(FONT_BIN:%=$(OUT)/%.o)
  $(OUT)/%.cff.o : %.cff ; $(OBJCOPY_CMD)
  $(OUT)/%.otf.o : %.otf ; $(OBJCOPY_CMD)
  $(OUT)/%.ttf.o : %.ttf ; $(OBJCOPY_CMD)
  $(OUT)/%.ttc.o : %.ttc ; $(OBJCOPY_CMD)
else
  MUPDF_OBJ += $(FONT_GEN:%.c=$(OUT)/%.o)
endif

generate: $(FONT_GEN)

# --- Generated hyphenation patterns ---

ifeq (,$(findstring -DFZ_ENABLE_HYPHEN=0,$(CFLAGS)))
  ifeq (,$(findstring -DFZ_ENABLE_HYPHEN_ALL=0,$(CFLAGS)))
    HYPH_BIN = resources/hyphen/hyph-all.zip
  else
    HYPH_BIN = resources/hyphen/hyph-std.zip
  endif
endif

HYPH_GEN := $(HYPH_BIN:%=generated/%.c)

generated/%.zip.c : %.zip $(HEXDUMP_SH) ; $(QUIET_GEN) $(MKTGTDIR) ; bash $(HEXDUMP_SH) > $@ $<

ifeq ($(HAVE_OBJCOPY),yes)
  MUPDF_OBJ += $(HYPH_BIN:%.zip=$(OUT)/%.zip.o)
  $(OUT)/%.zip.o : %.zip ; $(OBJCOPY_CMD)
else
  MUPDF_OBJ += $(HYPH_GEN:%.c=$(OUT)/%.o)
endif

# NOTE: Run scripts/runhyphen.sh to generate new hyphenation zip files.
generate: $(HYPH_GEN)

# --- Generated ICC profiles ---

source/fitz/icc/%.icc.h: resources/icc/%.icc
	$(QUIET_GEN) xxd -i $< | \
		sed 's/unsigned/static const unsigned/' | \
		sed '1i// This is an automatically generated file. Do not edit.' \
		> $@

generate: source/fitz/icc/gray.icc.h
generate: source/fitz/icc/rgb.icc.h
generate: source/fitz/icc/cmyk.icc.h
generate: source/fitz/icc/lab.icc.h
generate: source/fitz/icc/ps_gray.icc.h
generate: source/fitz/icc/ps_rgb.icc.h
generate: source/fitz/icc/ps_cmyk.icc.h

# --- Generated CMap files ---

CMAP_GEN := $(notdir $(sort $(wildcard resources/cmaps/*)))
CMAP_GEN := $(CMAP_GEN:%=source/pdf/cmaps/%.h)

source/pdf/cmaps/%.h: resources/cmaps/% scripts/cmapdump.py
	$(QUIET_GEN) python3 scripts/cmapdump.py > $@ $<

generate: $(CMAP_GEN)

# --- Generated embedded javascript files ---

source/pdf/js/%.js.h: source/pdf/js/%.js scripts/jsdump.sed
	$(QUIET_GEN) sed -f scripts/jsdump.sed < $< > $@

generate: source/pdf/js/util.js.h

# --- Generated perfect hash source files ---

source/html/css-properties.h: source/html/css-properties.gperf
	$(QUIET_GEN) gperf > $@ $<

generate: source/html/css-properties.h

# --- Library ---

ifeq ($(shared),yes)
  $(OUT)/libmupdf.$(SO)$(SO_VERSION): $(MUPDF_OBJ) $(THIRD_OBJ)
	$(LINK_SO_CMD) $(THIRD_LIBS) $(LIBCRYPTO_LIBS) $(LIBS)
  ifeq ($(OS),OpenBSD)
    # should never create symlink
    MUPDF_LIB = $(OUT)/libmupdf.$(SO)$(SO_VERSION)
  else
    MUPDF_LIB = $(OUT)/libmupdf.$(SO)
    ifneq ($(SO_VERSION),)
      # create symlink with soname if needed
      $(OUT)/libmupdf.$(SO): $(OUT)/libmupdf.$(SO)$(SO_VERSION)
	$(SYMLINK_CMD) $(notdir $<) $@
    endif
  endif
else
  MUPDF_LIB = $(OUT)/libmupdf.a
  ifneq ($(THIRD_OBJ),)
    # omit libmupdf-third if there is nothing in it
    THIRD_LIB = $(OUT)/libmupdf-third.a
  endif
  $(MUPDF_LIB) : $(MUPDF_OBJ)
  $(THIRD_LIB) : $(THIRD_OBJ)
endif

ifneq ($(USE_SYSTEM_GLUT),yes)
  THIRD_GLUT_LIB = $(OUT)/libmupdf-glut.a
  $(THIRD_GLUT_LIB) : $(THIRD_GLUT_OBJ)
endif

THREAD_LIB = $(OUT)/libmupdf-threads.a
$(THREAD_LIB) : $(THREAD_OBJ)

PKCS7_LIB = $(OUT)/libmupdf-pkcs7.a
$(PKCS7_LIB) : $(PKCS7_OBJ)

# --- Main tools and viewers ---

MUTOOL_SRC := source/tools/mutool.c
MUTOOL_SRC += source/tools/muconvert.c
MUTOOL_SRC += source/tools/mudraw.c
MUTOOL_SRC += source/tools/murun.c
MUTOOL_SRC += source/tools/mutrace.c
MUTOOL_SRC += source/tools/mugrep.c

=== platform/wasm/Makefile ===
default:
	@npm install -s
	bash tools/build.sh

memento:
	BUILD=memento \
	bash tools/build.sh

clean:
	rm -f LICENSE
	rm -rf dist
	rm -f lib/mupdf-wasm.d.ts
	rm -rf ../../build/wasm

nuke: clean
	rm -rf node_modules
	rm -f package-lock.json

=== debian/changelog ===
mupdf (1.27.0+ds1-2ubuntu1) resolute; urgency=medium

  * Disable LTO to avoid many changes to symbols file
  * Mark symbols disappearing with -O3 as optional

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 27 Jan 2026 18:53:09 +0000

=== debian/control ===
Source: mupdf
Section: text
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
Uploaders: Daniel Echeverri <epsilon@debian.org>
Build-Depends: afdko-bin:native,
               debhelper-compat (= 13),
               fonts-droid-fallback,
               fonts-noto-cjk,
               fonts-noto-core,
               fonts-noto-ui-core,
               fonts-sil-charis,
               fonts-urw-base35,
               freeglut3-dev,
               furo,
               libgl-dev,
               libfreetype-dev,
               libgumbo-dev,
               libharfbuzz-dev,
               libjbig2dec0-dev (>= 0.20),
               libjpeg-dev,
               liblcms2-dev,
               libmujs-dev (>= 1.3.8),
               libopenjp2-7-dev,
               libssl-dev,
               libx11-dev,
               libxext-dev,
               libxrandr-dev,
               libbrotli-dev,
               libzxing-dev,
               pkgconf,
	       dh-sequence-python3,
               python3-all-dev,
               python3-clang,
               python3-docutils,
               python3-roman,
               python3-pygments,
               python3-sphinx-copybutton,
               python3-sphinx-rtd-theme,
               python3-myst-parser,
	       python3-sphinx,
               rst2pdf,
               swig,
               texlive-fonts-extra,
               unzip,
               zlib1g-dev
Standards-Version: 4.7.2
Homepage: https://mupdf.com/
Vcs-Git: https://salsa.debian.org/debian/mupdf.git
Vcs-Browser: https://salsa.debian.org/debian/mupdf

Package: libmupdf-dev
Architecture: any
Section: libdevel
Depends: libfreetype-dev, libmupdf27.0 (= ${binary:Version}), ${misc:Depends}
Built-Using: ${Built-Using}
Description: development files for the MuPDF viewer
 MuPDF is a lightweight PDF viewer and toolkit written in portable C.
 It also reads XPS, OpenXPS and ePub documents.
 .
 This package contains the static the unversioned library and headers.

Package: libmupdf27.0
Architecture: any
Section: libs
Depends: libjbig2dec0 (>= 0.19), ${misc:Depends}, ${shlibs:Depends}
Built-Using: ${Built-Using}
Description: shared library for the MuPDF viewer
 MuPDF is a lightweight PDF viewer and toolkit written in portable C.
 It also reads XPS, OpenXPS and ePub documents.
 .
 This package contains the shared library libmupdf and libmupdfcpp.

Package: mupdf
Architecture: any
Depends: libjbig2dec0 (>= 0.19),
         libjs-sphinxdoc,
         libmupdf27.0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
	     ${sphinxdoc:Depends}
Built-Using: ${Built-Using}
Suggests: mupdf-tools
Provides: pdf-viewer
Description: lightweight PDF viewer
 MuPDF is a lightweight PDF viewer and toolkit written in portable C.
 It also reads XPS, OpenXPS and ePub documents.
 .
 The renderer in MuPDF is tailored for high quality anti-aliased graphics.
 It renders text with metrics and spacing accurate to within fractions of a
 pixel for the highest fidelity in reproducing the look of a printed page
 on screen.

Package: mupdf-tools
Architecture: any
Depends: libjbig2dec0 (>= 0.19),
         libmupdf27.0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: command line tools for the MuPDF viewer
 MuPDF is a lightweight PDF viewer and toolkit written in portable C.
 It also reads XPS, OpenXPS and ePub documents.
 .
 This package contains command line tools using the MuPDF library:
  - mutool - tool for clean, extract, inspect PDF documents and
             render PDF/XPS/CBZ documents.

Package: python3-mupdf
Architecture: any
Depends: libmupdf27.0 (= ${binary:Version}), ${python3:Depends}, ${misc:Depends}, ${shlibs:Depends}
Description: Python bindings for MuPDF library
 MuPDF is a lightweight PDF viewer and toolkit written in portable C.
 It also reads XPS, OpenXPS and ePub documents.
 .
 This package contains the contains low level mupdf Python bindings.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Enable verbose builds to detect missing (hardening) flags.
#export verbose=1

# This has to be exported to make some magic below work.
export DH_OPTIONS
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
export PY3VERS := $(shell py3versions -vs)
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

BUILD_DATE  = $(shell LC_ALL=C date -u "+%B %d, %Y" -d "@$(SOURCE_DATE_EPOCH)")
SPHINXOPTS := -N -D html_last_updated_fmt="$(BUILD_DATE)"


# Set CC for crossbuild
export CC_FOR_BUILD ?= cc
export PKG_CONFIG ?= $(DEB_HOST_GNU_TYPE)-pkg-config
# The build system doesn't use CPPFLAGS, pass them to CFLAGS to enable the
# missing (hardening) flags.
CFLAGS += $(CPPFLAGS)
# ICC support needs patched thirdparty liblcms2-art
CFLAGS += -DFZ_ENABLE_ICC=0
CFLAGS += -fPIC
CFLAGS += -DNDEBUG

ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
    CFLAGS += -O0
else
    CFLAGS += -O2
endif

BUILD_FLAGS = build=debug shared=yes OS=Linux XCFLAGS="$(CFLAGS)" XLDFLAGS="$(LDFLAGS)" XCXXFLAGS="-DNDEBUG"
BUILD_FLAGS += LINUX_OR_OPENBSD=yes
# Force using system library
BUILD_FLAGS += USE_SYSTEM_MUJS=yes
BUILD_FLAGS += USE_SYSTEM_LIBS=yes
# Force using system lcms2 (was not included in default system library set)
BUILD_FLAGS += USE_SYSTEM_LCMS2=yes
BUILD_FLAGS += LD=$(DEB_HOST_GNU_TYPE)-ld

ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
	BUILD_FLAGS += verbose=yes
endif

ifeq ($(DEB_TARGET_ARCH),mips64el)
	BUILD_FLAGS += HAVE_OBJCOPY=no
endif

override_dh_clean:
	find resources/fonts/urw/input/*.t1 -maxdepth 1 ! -name 'NimbusBoxes.t1' ! -name '.' -exec rm -rf {} +
	dh_clean

override_dh_auto_build:
	-sed -e s,@@DEB_HOST_MULTIARCH@@,${DEB_HOST_MULTIARCH}, debian/mupdf.pc.in > debian/mupdf.pc
	debian/replace-fonts.sh
	-mkdir source/pdf/cmaps
	sh scripts/runcmapdump.sh
	dh_auto_build -- $(BUILD_FLAGS) VENV_FLAG='' Py_LIMITED_API=1 shared c++ python extra-apps

override_dh_auto_install:
	dh_auto_install --  prefix=/usr $(BUILD_FLAGS) VENV_FLAG='' Py_LIMITED_API=1 install-shared-c++
	dh_auto_install -- prefix=/usr $(BUILD_FLAGS) VENV_FLAG='' Py_LIMITED_API=1 install-extra-apps
	for py in $(PY3VERS); do \
		dh_auto_install -- pydir=/usr/lib/python$$py/dist-packages prefix=/usr $(BUILD_FLAGS) VENV_FLAG='' Py_LIMITED_API=1 install-shared-python; \
	done
	install -m744 -T $(CURDIR)/debian/mupdf.sh $(CURDIR)/debian/tmp/usr/bin/mupdf
	sh debian/install_icons.sh
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) -C $(CURDIR)/debian/tests test LIB_DIR=$(CURDIR)/build/shared-debug-Py_LIMITED_API_0x030d0000
endif

override_dh_gencontrol:
	dh_gencontrol -- -VBuilt-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W fonts-droid-fallback fonts-noto-cjk fonts-noto-core fonts-sil-charis fonts-urw-base35 texlive-fonts-extra)"

override_dh_missing:
	dh_missing --list-missing -X COPYING

override_dh_installman:
	#convert to manpage
	rst2man docs/tools/mupdf-gl.rst $(CURDIR)/debian/tmp/usr/share/man/mupdf-gl.1
	dh_installman

override_dh_sphinxdoc:
ifeq (,$(findstring nodoc, $(DEB_BUILD_OPTIONS)))
	PYTHONPATH=src python3 -m sphinx -b html $(SPHINXOPTS) docs $(CURDIR)/debian/mupdf/usr/share/doc/mupdf/
	dh_sphinxdoc
endif

override_dh_installdocs:
	rm -rf $(CURDIR)/debian/mupdf/usr/share/doc/mupdf/html/_sources
	rm -rf $(CURDIR)/debian/mupdf/usr/share/doc/mupdf/html/_static/[doctools.js,language_data.js,searchtools.js]
	rm -rf $(CURDIR)/debian/mupdf/usr/share/doc/mupdf/doctrees
	dh_installdocs

override_dh_makeshlibs:
	dh_makeshlibs -- -v$(DEB_VERSION_UPSTREAM) -plibmupdf$(DEB_VERSION_UPSTREAM)

%:
	dh $@ --no-parallel --with sphinxdoc,python3

=== debian/watch ===
version=4
opts="repacksuffix=+ds1,\
searchmode=plain,\
dversionmangle=s/\+ds\d*$//,\
downloadurlmangle=s|.*mupdf-([\d.]+)-source\.tar\.gz|https://casper.mupdf.com/downloads/archive/mupdf-$1-source.tar.gz|,\
filenamemangle=s/.*mupdf-(.+)-source\.tar\.gz/mupdf-$1.tar.gz/" \
https://mupdf.com/releases?product=MuPDF \
mupdf-([\d.]+)-source\.tar\.gz
